package com.logicbig.example;

import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.boot.test.context.TestConfiguration;
import org.springframework.context.annotation.Bean;
import org.springframework.test.context.junit4.SpringRunner;

@RunWith(SpringRunner.class)
@SpringBootTest
public class MyHelloProcessorTest {
    @Autowired
    private MyHelloProcessor myHelloProcessor;

    @Test
    public void testSayHi() {
        String message = myHelloProcessor.sayHi("Joe");
        System.out.println(message);
        Assert.assertEquals(message, "Test hello: Joe");
    }

    @TestConfiguration
    static class MyTestConfig {
        @Bean
        public HelloService helloService() {
            return new HelloService() {
                @Override
                public String getMessage(String name) {
                    return "Test hello: " + name;
                }
            };
        }
    }
}